Unit aes0e0_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AV02E_p, AV04E_p;

procedure aes0e0(var A :Array of Extended; var B :Array of Extended;
                var B2 :Array of Extended; var D :Array of Extended;
                var E :Array of Extended; var F :Array of Extended;
                var Y :Array of Extended; var Z :Array of Extended;
                var LOG :Array of Boolean; N :Integer; M1 :Integer;
                M2 :Integer; NUM :Integer; var EV :Array of Extended;
                var V :Array of Extended; MM :Integer;
                var NIT :Array of Integer);

implementation

procedure aes0e0(var A :Array of Extended; var B :Array of Extended;
                var B2 :Array of Extended; var D :Array of Extended;
                var E :Array of Extended; var F :Array of Extended;
                var Y :Array of Extended; var Z :Array of Extended;
                var LOG :Array of Boolean; N :Integer; M1 :Integer;
                M2 :Integer; NUM :Integer; var EV :Array of Extended;
                var V :Array of Extended; MM :Integer;
                var NIT :Array of Integer);
var
I,I1,I2,I3,IJ,IP,IT,J,J1,J2,J21,K,L,M,MET,NJ,NUM1,NUM2 :Integer;
ALFA,BI,DI,EI,EPS,EPS1,EPS2,EVM,G,R,SNORM,T,U,W,WM,X,XL,XL0,XU,
   XU0 :Extended;
const
SYS051 :Extended = 1.1107652e-16;
SYS056 :Extended = 5.56268464627e-308;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230,_240,_250,_260,_270,_280,_290,
_300,_310,_320,_330,_340,_350,_360,_370,_380,_390,_400,_410,_420;
begin
if ( N <>  1 )
 then goto _10;
EV[0] := A[0];
V[0+0*MM] := 1.e0;
goto _420;
_10:
if ( M1 <=  M2 )
 then goto _30;
J1 := N - M1 + 1;
J2 := N - M2 + 1;
for I:=1 to N do
 begin
  D[I-1] := -A[I-1];
  E[I-1] := -B[I-1];
_20:
 end;
goto _50;
_30:
J1 := M1;
J2 := M2;
for I:=1 to N do
 begin
  D[I-1] := A[I-1];
  E[I-1] := B[I-1];
_40:
 end;
_50:
M := Abs(M1-M2) + 1;
DI := D[0];
XU := DI;
XL := DI;
R := 0.e0;
for I:=2 to N do
 begin
  EI := Abs(E[I-1]);
  W := R + EI;
  XU := EMax1(XU,DI+W);
  XL := EMin1(XL,DI-W);
  DI := D[I-1];
  R := EI;
_60:
 end;
XU0 := EMax1(XU,DI+EI);
XL0 := EMin1(XL,DI-EI);
EVM := EMax1(Abs(XU0),Abs(XL0));
T := 2.e0*SYS051;
EPS := EVM*SYS051;
EPS := EMax1(EPS,SYS056);
WM := EMax1(EPS/(2.e0*N*SYS056),1.e0);
for I:=1 to N do
 begin
  if ( Abs(E[I-1]) >  EPS )
   then goto _70;
  E[I-1] := 0.e0;
  B2[I-1] := 0.e0;
_70:
 end;
NUM1 := NUM + 1;
NUM2 := NUM + M;
IP := NIT[NUM1-1];
if ( IP =  -2 )
 then EPS := EMax1(EPS,F[0]);
if ( IP >  0 )
 then goto _200;
B2[0] := 0.e0;
L := M + NUM;
J := J2;
MET := 170;
XL := XL0;
_80:
XU := XU0;
NJ := N - J + 1;
_90:
X := (XU + XL)*0.5e0;
if ( (XU - XL) <=  ((Abs(XU)+Abs(XL))*T + EPS) )
 then goto _160;
K := 0;
U := 1.e0;
IJ := 0;
for I:=1 to N do
 begin
  if ( U <>  0.e0 )
   then goto _100;
  W := Abs(E[I-1])/SYS051;
  goto _110;
_100:
  W := B2[I-1]/U;
_110:
  U := D[I-1] - X - W;
  if ( U <  0.e0 )
   then goto _120;
  IJ := IJ + 1;
  if ( IJ =  NJ )
   then goto _140;
  goto _130;
_120:
  K := K + 1;
  if ( K =  J )
   then goto _150;
_130:
 end;
_140:
XL := X;
goto _90;
_150:
XU := X;
goto _90;
_160:
EV[L-1] := X;
if ( MET=170 ) then goto _170 else
if ( MET=180 ) then goto _180;
_170:
XU0 := XU;
XL := XL0;
MET := 180;
if ( M =  1 )
 then goto _200;
J21 := J2 - 1;
L := NUM;
//for J:=J1 to J21 do
J:=J1;
while ( J<=J21 ) do  // , ..        
 begin
  L := L + 1;
  goto _80;
_180:
  inc(J); //  
 end;
if ( M1 <=  M2 )
 then goto _200;
for I:=NUM1 to NUM2 do
 begin
  EV[I-1] := -EV[I-1];
_190:
 end;
_200:
if ( IP <=  -1 )
 then goto _420;
EPS1 := EPS*10.e0*N*Sqrt((N));
EPS2 := EVM*1.e-3;
K := 0;
J1 := NUM;
for J:=NUM1 to NUM2 do
 begin
  X := EV[J-1];
  U := A[0] - X;
  W := B[1];
  for I:=2 to N do
   begin
    BI := B[I-1];
    LOG[I-1] := ( (Abs(BI) >  Abs(U)) );
    if ( LOG[I-1] )
     then goto _210;
    if ( Abs(U) <=  EPS )
     then U := EPS;
    R := BI/U;
    Y[I-1] := R;
    D[I-2] := U;
    E[I-2] := W;
    F[I-2] := 0.e0;
    U := A[I-1] - X - R*W;
    if ( I <>  N )
     then W := B[I+0];
    goto _220;
_210:
    R := U/BI;
    Y[I-1] := R;
    D[I-2] := BI;
    E[I-2] := A[I-1] - X;
    if ( I <>  N )
     then F[I-2] := B[I+0];
    U := W - R*E[I-2];
    W := -R*F[I-2];
_220:
   end;
  if ( Abs(U) <=  EPS )
   then U := EPS;
  D[N-1] := U;
  E[N-1] := 0.e0;
  F[N-2] := 0.e0;
  F[N-1] := 0.e0;
  IT := 0;
  if ( IP =  2 )
   then goto _240;
  for I:=1 to N do
   begin
    Z[I-1] := 1.e0;
_230:
   end;
  goto _310;
_240:
  for I:=1 to N do
   begin
    Z[I-1] := V[(I-1)+(J-1)*MM];
_250:
   end;
  I := N;  // -           
  goto _280;
_260:
  for I:=1 to N do
   begin
    Z[I-1] := 0.e0;
_270:
   end;
  if ( K =  N )
   then K := 0;
  K := K + 1;
  Z[K-1] := 1.e0;
//  for I:=2 to N do
  I:=2;
  while ( I<=N ) do   // , ..     
   begin
_280:
    if ( LOG[I-1] )
     then goto _290;
    Z[I-1] := Z[I-1] - Y[I-1]*Z[I-2];
    goto _300;
_290:
    U := Z[I-2];
    Z[I-2] := Z[I-1];
    Z[I-1] := U - Y[I-1]*Z[I-1];
_300:
    inc(I); //  
   end;
_310:
  ALFA := 1.e0;
  for I2:=1 to N do
   begin
    I := N + 1 - I2;
//    R := 1.e0;
    G := ALFA*Z[I-1] - U*E[I-1] - W*F[I-1];
    DI := D[I-1];
    if ( Abs(G) <=  WM ) 
     then goto _330;
    R := DI/G;
    Z[I-1] := 1.e0;
    ALFA := R*ALFA;
    I1 := I + 1;
    U := 1.e0;
    if ( I =  N ) 
     then goto _340;
    for I3:=I1 to N do
     begin
      Z[I3-1] := Z[I3-1]*R;
_320:
     end;
    W := Z[I+0];
    goto _340;
_330:
    R := G/DI;
    Z[I-1] := R;
    W := U;
    U := R;
_340:
   end;
  IT := IT + 1;
  if ( J1 =  0 ) 
   then goto _370;
  for J2:=1 to J1 do
   begin
    if ( Abs(X-EV[J2-1]) >  EPS2 )
     then goto _360;
    G := AV04E(Z,V[0+(J2-1)*MM],N);
    for I:=1 to N do
     begin
      Z[I-1] := Z[I-1] - G*V[(I-1)+(J2-1)*MM];
_350:
     end;
_360:
   end;
_370:
  SNORM := 0.e0;
  for I:=1 to N do
   begin
    SNORM := SNORM + Abs(Z[I-1]);
_380:
   end;
  if ( SNORM =  0.e0 ) 
   then goto _260;
  R := Abs(ALFA)/SNORM;
  if ( R <=  EPS1 )
   then goto _390;
  if ( R >=  0.1e0 )
   then goto _260;
  I := N;  // -           
  goto _280;
_390:
  G := 1.e0/AV02E(Z,N);
  for I:=1 to N do
   begin
    V[(I-1)+(J-1)*MM] := Z[I-1]*G;
_400:
   end;
  NIT[J-1] := IT;
  J1 := J;
_410:
 end;
_420:
end;

end.
