Unit ags0e1_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AES0E0_p, AV04E1_p, AVZ6E_p, AM05E_p;

procedure ags0e1(N :Integer; KL :Integer; KR :Integer;
                MMAX :Integer; var VJ :Array of Extended;
                var PJ :Array of Extended; FA :Proc_F5AE; FB :Proc_F5AE;
                SB :Proc_F5AE; EPS0 :Extended; K3 :Integer; var IP :Integer;
                var W :Array of Extended; var D :Array of Extended;
                var E :Array of Extended; var E2 :Array of Extended;
                var S :Array of Extended; var RR :Array of Extended;
                var LO :Array of Boolean; var IR :Array of Integer;
                var TETA :Array of Extended; var T2 :Array of Extended;
                var BS :Array of Extended; var TETA2 :Array of Extended;
                var BS2 :Array of Extended; var TAU :Array of Extended;
                var TAU1 :Array of Extended; var TETA1 :Array of Extended;
                var BS1 :Array of Extended; var V :Array of Extended;
                var Y :Array of Extended);

implementation

procedure ags0e1(N :Integer; KL :Integer; KR :Integer;
                MMAX :Integer; var VJ :Array of Extended;
                var PJ :Array of Extended; FA :Proc_F5AE; FB :Proc_F5AE;
                SB :Proc_F5AE; EPS0 :Extended; K3 :Integer; var IP :Integer;
                var W :Array of Extended; var D :Array of Extended;
                var E :Array of Extended; var E2 :Array of Extended;
                var S :Array of Extended; var RR :Array of Extended;
                var LO :Array of Boolean; var IR :Array of Integer;
                var TETA :Array of Extended; var T2 :Array of Extended;
                var BS :Array of Extended; var TETA2 :Array of Extended;
                var BS2 :Array of Extended; var TAU :Array of Extended;
                var TAU1 :Array of Extended; var TETA1 :Array of Extended;
                var BS1 :Array of Extended; var V :Array of Extended;
                var Y :Array of Extended);
var
I,I0,I1,I2,I3,I4,I5,I6,IGR,IGR2,IP0,J,JL,JR,K1,L,L1,L2,L3,L4,M,M1,ML,
   ML0,ML1,MR,NG,NG0,NG2,NUM,IP1,J1 :Integer;
GT :Real;
ALFA,BETA,BETA1,ENJ2,EPS,EPS1,EPS10,EPS2,EPS3,EPS4,ER,F,G,R,R1,RM,
   SIGMA,TETAM,EPS31 :Extended;
LOG :Boolean;
const
RELMCH :Extended = 1.111307226797642e-16;
SYS020 :Extended = 0.69314718055994530941723212145817;
label
_5,_10,_20,_30,_35,_40,_45,_50,_60,_70,_80,_90,_100,_110,_120,_125,
_130,_140,_150,_160,_170,_180,_190,_200,_210,_220,_230,_240,_250,_270,
_280,_290,_300,_310,_320,_330,_340,_350,_360,_370,_380,_390,_400,_405,
_410,_420,_430,_440,_530,_540,_550,_554,_555,_556,_557,_560,_570,_580,
_640,_650,_660,_670,_740,_750,_760,_770;
begin
EPS2  := Sqrt(RELMCH);
R  := Ln((N))/SYS020;
EPS10  := EPS2*R/2.e0;
EPS4  := RELMCH*R;
L1  := MMAX + 1;
L2  := L1 + MMAX;
L3  := L2 + MMAX;
L4  := L3 + MMAX;
K1  := KR + KL;
I0  := IP;
IP  := 0;
_5:
FB(VJ,PJ,N);
R  := Sqrt(AV04E1(VJ,PJ,N));
if ( R  <>  0.e0 ) 
 then goto _20;
for I:=1 to N do
 begin
  VJ[I-1] := 1.e0;
_10:
 end;
goto _5;
_20:
F  := 1.e0/R;
for I:=1 to N do
 begin
  PJ[I-1] := PJ[I-1]*F;
  W[I-1] := 0.e0;
  VJ[I-1] := VJ[I-1]*F;
_30:
 end;
BETA1  := 0.e0;
ML  := 1;
MR  := 0;
NG2  := 0;
SIGMA  := 0.e0;
IP0  := 0;
ENJ2  := 0.0e0;
TETAM  := 1.e0;
EPS  := EPS0/2.e0;
EPS3  := EPS4*TETAM;
EPS31  := EPS4;
for J:=1 to MMAX do
 begin
  for I:=1 to N do
   begin
    V[(I-1)+(J-1)*N] := VJ[I-1];
_35:
   end;
  IP1 := 0;
  FA(VJ,W,N);
  ALFA  := AV04E1(W,VJ,N);
  E[J-1] := BETA1;
  E2[J-1] := BETA1*BETA1;
  D[J-1] := ALFA;
  if ( J = MMAX )
   then goto _660;
  for I:=1 to N do
   begin
    W[I-1] := W[I-1] - ALFA*PJ[I-1];
_40:
   end;
  SB(W,VJ,N);
  J1 := J+1;
  for I:=1 to N do
   begin
    V[(I-1)+(J1-1)*N] := VJ[I-1];
_45:
   end;
  BETA  := Sqrt(AV04E1(W,VJ,N));
_50:
  R := EPS10 * TETAM;
  EPS1  := EMax1(R,EPS3);
  if ( BETA  <=  EPS31*TETAM ) 
   then IP0  := 4;
  if ( EPS1 >  R*128.e0 ) 
   then IP0  := 5;
  if ( BETA  <=  EPS1  ) and (  J  >  K3 ) 
   then IP0  := 2;
  if ( IP0  <>  0 ) 
   then goto _670;
  if ( BETA <= EPS ) and ( J > K1 ) and ( I0 = 0 )
   then goto _670;
  if ( BETA  >  EPS3 ) 
   then goto _60;
  ML  := J;
  MR  := 0;
_60:
  NG  := 0;
  ML0  := 1;
  LOG  := True;
  if ( J  <  K1  ) or (  I0  =  1 ) 
   then LOG  := False;
_70:
  M  := ML + MR;
  NUM  := ML0 - 1;
  IR[ML0-1] := 0;
  if ( M  >  K3 ) 
   then IP0  := 2;
  if ( IP0  =  2 ) 
   then goto _670;
  AES0E0(D,E,E2,RR,RR[L1-1],RR[L2-1],RR[L3-1],
       RR[L4-1],LO,J,ML0,ML,NUM,TETA,S,MMAX,IR);
  for I:=ML0 to ML do
   begin
    R  := Abs(S[(J-1)+(I-1)*MMAX])*BETA;
    BS[I-1] := R;
    if ( R  <=  EPS1 ) 
     then NG  := NG + 1;
    if ( I  >  KL ) 
     then goto _80;
    if ( R  >  EPS ) 
     then LOG  := False;
_80:
   end;
  if ( MR  =  0 ) 
   then goto _120;
  if ( M  =  J ) 
   then goto _90;
  if ( BS[ML-1] >  EPS1  ) and (  ( not  LOG  ) or (  ML  >=  KL) )
   then goto _90;
  ML  := ML + 1;
  ML0  := ML;
  goto _70;
_90:
  ML1  := ML + 1;
  if ( MR  =  0 ) 
   then goto _120;
  M1  := ML1;
  JR  := J;
  JL  := J - MR + 1;
_100:
  NUM  := M1 - 1;
  IR[M1-1] := 0;
  AES0E0(D,E,E2,RR,RR[L1-1],RR[L2-1],RR[L3-1],
       RR[L4-1],LO,J,JR,JL,NUM,TETA,S,MMAX,IR);
  for I:=M1 to M do
   begin
    R  := Abs(S[(J-1)+(I-1)*MMAX])*BETA;
    BS[I-1] := R;
    if ( R  <=  EPS1 ) 
     then NG  := NG + 1;
    if ( I  >  ML + KR ) 
     then goto _110;
    if ( R  >  EPS ) 
     then LOG  := False;
_110:
   end;
  if ( M  =  J ) 
   then goto _120;
  if ( BS[M-1] >  EPS1  ) and (  ( not  LOG  ) or (  MR  >=  KR) )
   then goto _120;
  M  := M + 1;
  if ( M  >  K3 ) 
   then IP0  := 2;
  if ( IP0  =  2 ) 
   then goto _670;
  M1  := M;
  JL  := JL - 1;
  MR  := MR + 1;
  JR  := JL;
  goto _100;
_120:
  if ( ML  <  KL  ) or (  MR  <  KR ) 
   then goto _125;
  if ( LOG ) 
   then goto _670;
_125:
  if ( MR  =  0 ) 
   then ML1  := M;
  TETAM  := EMax1(EMax1(Abs(TETA[0]),Abs(TETA[ML1-1])),TETAM);
  if ( NG  <>  0 ) 
   then goto _130;
  if ( NG2  =  0 ) 
   then BETA1  := BETA;
  if ( NG2  =  0 ) 
   then goto _540;
  NG  := NG2;
  goto _360;
_130:
  NG  := NG2;
  if ( MR  =  0 ) 
   then goto _160;
  for I:=ML1 to M do
   begin
    I1  := M + ML1 - I;
    RR[I-1] := BS[I1-1];
_140:
   end;
  for I:=ML1 to M do
   begin
    BS[I-1] := RR[I-1];
    I1  := M + ML1 - I;
    RR[I-1] := TETA[I1-1];
_150:
   end;
_160:
  for I:=1 to ML do
   begin
    RR[I-1] := TETA[I-1];
_170:
   end;
  if ( NG2  =  0 ) 
   then goto _190;
  for I:=1 to NG2 do
   begin
    T2[I-1] := TETA2[I-1];
_180:
   end;
  AVZ6E(T2,NG2,IR);
_190:
  NG0  := 0;
  I2  := 0;
  for I:=1 to M do
   begin
    if ( I  <=  I2 ) 
     then goto _340;
    if ( BS[I-1] >  EPS1 ) 
     then goto _340;
    R  := RR[I-1];
    IGR  := 1;
    I1  := I;
    I2  := I;
    if ( I1  =  M ) 
     then goto _210;
    I5  := I1 + 1;
    for I3:=I5 to M do
     begin
      R1  := RR[I3-1];
      if ( Abs(R1-R) >  EPS1 ) 
       then goto _210;
      I2  := I2 + 1;
      if ( BS[I3-1] >  EPS1 ) 
       then goto _200;
      IGR  := IGR + 1;
_200:
     end;
_210:
    IGR2  := 0;
    if ( NG0  =  NG2 ) 
     then goto _230;
    I5  := NG0 + 1;
    for I3:=I5 to NG2 do
     begin
      R1  := T2[I3-1];
      if ( Abs(R1-R) >  EPS1 ) 
       then goto _220;
      IGR2  := IGR2 + 1;
      NG0  := I3;
_220:
     end;
_230:
    if ( IGR  <=  IGR2 ) 
     then goto _340;
    for I6:=I1 to I2 do
     begin
      if ( BS[I6-1] >  EPS1 ) 
       then goto _330;
      I4  := I6;
      if ( I4  >  ML ) 
       then I4  := M + ML1 - I4;
      for I3:=1 to N do
       begin
        VJ[I3-1] := 0.e0;
_240:
       end;
      for I5:=1 to J do
       begin
        G  := S[(I5-1)+(I4-1)*MMAX];
        for I3:=1 to N do
         begin
          VJ[I3-1] := VJ[I3-1] + V[(I3-1)+(I5-1)*N]*G;
_250:
         end;
_270:
       end;
      if ( NG  =  0 ) 
       then goto _300;
      FB(VJ,W,N);
      for L:=1 to NG do
       begin
        G  := AV04E1(W,Y[0+(L-1)*N],N);
        for I3:=1 to N do
         begin
          VJ[I3-1] := VJ[I3-1] - G*Y[(I3-1)+(L-1)*N];
_280:
         end;
_290:
       end;
_300:
      FB(VJ,W,N);
      R  := Sqrt(AV04E1(VJ,W,N));
      if ( R  <=  1.e0/(2.e0*Sqrt(I2-I1+1.e0)) )
       then goto _330;
      F  := 1.e0/R;
      NG := NG+1;
      if ( IP1 = 0 )
       then IP1 := 1;
      for I3:=1 to N do
       begin
        R := VJ[I3-1]*F;
        VJ[I3-1] := R;
        Y[(I3-1)+(NG-1)*N] := R;
        PJ[I3-1] := 0.e0;
_310:
       end;
      FA(VJ,PJ,N);
      R  := AV04E1(VJ,PJ,N);
      R1 := R*F;
      for I3:=1 to N do
       begin
        PJ[I3-1] := PJ[I3-1] - R1*W[I3-1];
_320:
       end;
      ER  := Sqrt(AV04E1(PJ,PJ,N));
      BS2[NG-1] := ER;
      TETA2[NG-1] := R;
      TAU[NG-1] := -1.e0;
_330:
     end;
_340:
   end;
_350:
  if ( NG  =  0 ) 
   then BETA1  := BETA;
  if ( NG  =  0 ) 
   then goto _540;
_360:
  IGR  := NG - NG2;
  if ( NG2  =  0 ) 
   then goto _400;
  for I:=1 to NG2 do
   begin
    R  := TAU[I-1];
    R1  := R;
    if ( R1  <=  -1.e0 ) 
     then R  := RM;
    if ( R1  =  -1.e0 ) 
     then TAU[I-1] := -2.e0;
    if ( R1  =  -1.e0 ) 
     then goto _370;
    TAU[I-1] := (R*Abs(TETA2[I-1]-ALFA) + TAU1[I-1]*
    BETA1 + 3.e0*RELMCH*TETAM)/BETA;
    if ( TAU[I-1] <=  EPS2 ) 
     then goto _380;
    TAU[I-1] := -1.e0;
_370:
    IGR  := IGR + 1;
_380:
    TAU1[I-1] := R;
_390:
   end;
_400:
  IGR2  := 0;
  for I:=1 to N do
   begin
    VJ[I-1] := V[(I-1)+(J1-1)*N];
_405:
   end;
  FB(VJ,W,N);
  for I1:=1 to NG do
   begin
    if ( IGR2  =  IGR ) 
     then goto _430;
    if ( TAU[I1-1] >  -1.e0 ) 
     then goto _420;
    G  := AV04E1(W,Y[0+(I1-1)*N],N);
    IGR2  := IGR2 + 1;
    if ( Abs(G) <=  (RELMCH*BETA) ) 
     then goto _420;
    for I:=1 to N do
     begin
      VJ[I-1] := VJ[I-1] - G*Y[(I-1)+(I1-1)*N];
_410:
     end;
    G  := G*G;
    ENJ2  := ENJ2 + G;
_420:
   end;
_430:
  FB(VJ,W,N);
  BETA1  := Sqrt(AV04E1(VJ,W,N));
  R  := Sqrt(ENJ2);
  EPS3  := EMax1(EPS3,R);
  EPS  := EMax1(EPS,EPS3);
  if ( BETA1  >  EPS3 ) 
   then goto _530;
  if ( BETA1  <=  EPS31*TETAM ) 
   then IP0  := 4;
  if ( IP0  =  4 ) 
   then goto _670;
  if ( BETA1/BETA  >=  0.5e0 ) 
   then goto _530;
  for I1:=1 to NG do
   begin
    TAU[I1-1] := -1.e0;
_440:
   end;
  BETA  := BETA1;
  NG2  := NG;
  goto _50;
_530:
  RM  := EPS4*BETA/BETA1;
_540:
  F  := 1.e0/BETA1;
  if ( IP1 = 1 )
   then goto _554;
  for I:=1 to N do
   begin
    R := W[I-1];
    W[I-1] := PJ[I-1]*BETA1;
    PJ[I-1] := R*F;
    VJ[I-1] := VJ[I-1]*F;
_550:
   end;
  goto _557;
_554:
  for I:=1 to N do
   begin
    VJ[I-1] := VJ[I-1]*F;
    PJ[I-1] := W[I-1]*F;
_555:
   end;
  FB(V[0+(J-1)*N],W,N);
  for I:=1 to N do
   begin
    W[I-1] := W[I-1]*BETA1;
_556:
   end;
_557:
  if ( MR  <>  0 ) 
   then goto _580;
  if ( M  =  1 ) 
   then goto _570;
  M1  := M - 1;
  for I:=1 to M1 do
   begin
    if ( BS[I-1] <=  EPS1 ) 
     then goto _560;
    if ( BS[I+0] <=  EPS1 ) 
     then goto _560;
    ML  := I;
    MR  := J - ML;
    goto _580;
_560:
   end;
_570:
  ML  := J + 1;
_580:
_640:
  NG2  := NG;
_650:
 end;
_660:
J  := MMAX;
IP0  := 1;
_670:
ML  := KL;
MR  := KR;
if ( J  <  K1 ) 
 then ML  := J;
if ( J  <  K1 ) 
 then MR  := 0;
M  := ML + MR;
ML1  := ML + 1;
IR[0] := 0;
if ( ML  <>  0 )
 then AES0E0(D,E,E2,RR,RR[L1-1],RR[L2-1],RR[L3-1],RR[L4-1],
                        LO,J,1,ML,0,TETA,S,MMAX,IR);
JL  := J - MR + 1;
IR[ML1-1] := 0;
if ( MR  <>  0 )
 then AES0E0(D,E,E2,RR,RR[L1-1],RR[L2-1],RR[L3-1],RR[L4-1],
                        LO,J,J,JL,ML,TETA,S,MMAX,IR);
if ( EPS0  <  EPS  ) and (  IP0  =  0 ) 
 then IP0  := 3;
IP  := 0;
for I:=1 to M do
 begin
  AM05E(V,S[0+(I-1)*MMAX],W,N,J);
  FB(W,PJ,N);
  F  := 1.e0/Sqrt(AV04E1(W,PJ,N));
  for I3:=1 to N do
   begin
    VJ[I3-1] := W[I3-1]*F;
    W[I3-1] := 0.e0;
_740:
   end;
  FA(VJ,W,N);
  R  := AV04E1(VJ,W,N);
  R1 := R*F;
  for I3:=1 to N do
   begin
    W[I3-1] := W[I3-1] - R1*PJ[I3-1];
    Y[(I3-1)+(I-1)*N] := VJ[I3-1];
_750:
   end;
  SB(W,PJ,N);
  ER  := Sqrt(AV04E1(W,PJ,N));
  BS1[I-1] := ER;
  TETA1[I-1] := R;
  if ( ER  >  EPS0 ) 
   then IP  := IP0;
_760:
 end;
_770:
if ( J  <  K1 ) 
 then IP  := IP0;
if ( I0  =  1 ) and (  J  <>  MMAX ) 
 then IP  := IP0;
if ( IP0  =  4 ) 
 then IP  := 4;
RR[0] := (J);
end;

end.
